$:.unshift File.join(File.dirname(__FILE__), *%w[.. lib])

QUANDL_LOGGER = true

require 'pry'
require "quandl/cassandra"
require "quandl/fabricate"

Quandl::Logger.use Quandl::Logger::Outputs

Quandl::Cassandra.configure do |c|
  c.hosts         = ['localhost','192.168.50.4']
  c.consistency   = :one
end

# Create development keyspace if it does not already exists
keyspace_name = 'quandl_development'
columnfamily_name = 'posts'

if Quandl::Cassandra::Base.execute("SELECT * FROM system.schema_keyspaces WHERE keyspace_name = '#{keyspace_name}';", 'one').empty?
  Quandl::Cassandra::Base.execute("CREATE KEYSPACE #{keyspace_name} WITH REPLICATION = {'class' : 'SimpleStrategy', 'replication_factor': 1};", 'one')
end

results = Quandl::Cassandra::Base.execute("SELECT * FROM system.schema_columnfamilies WHERE keyspace_name = '#{keyspace_name}';")

# Create column family if it does not exist
if results.empty? or results.none? { |r| r['columnfamily_name'] == columnfamily_name }
  Quandl::Cassandra.configuration.keyspace = keyspace_name
  Quandl::Cassandra::Base.reset_connection
  Quandl::Cassandra::Base.execute("CREATE TABLE #{columnfamily_name} (
  id uuid PRIMARY KEY,
  content text,
  author varchar,
  updated_at timestamp );", 'one')
else
  puts "The column family #{columnfamily_name} already exists in keyspace #{keyspace_name}!"
end

Quandl::Cassandra.configuration.keyspace = keyspace_name
Quandl::Cassandra::Base.reset_connection

class Post < Quandl::Cassandra::Base

  table_name :posts

  after_initialize :default_attributes

  def default_attributes
    self.id = Cql::Uuid.new(SecureRandom.uuid) unless id.present?
  end

end

binding.pry

