# set host
Quandl::Cassandra.configure do |c|
  c.hosts         = ['192.168.50.4']
  c.consistency   = :one
end

keyspace_missing = Quandl::Cassandra::Base.execute("SELECT * FROM system.schema_keyspaces WHERE keyspace_name = 'quandl_cassandra_test';", 'one').empty?

Quandl::Cassandra::Base.execute("CREATE KEYSPACE quandl_cassandra_test WITH REPLICATION = {'class' : 'SimpleStrategy', 'replication_factor': 1};", 'one') if keyspace_missing

# reconnect to keyspace
Quandl::Cassandra.configuration.keyspace = 'quandl_cassandra_test'
Quandl::Cassandra::Base.reset_connection

# create posts table
begin
  Quandl::Cassandra::Base.execute("CREATE TABLE posts (
  id uuid PRIMARY KEY,
  content text,
  author varchar,
  updated_at timestamp );", 'one')
rescue
end

class Post < Quandl::Cassandra::Base; end
