require 'spec_helper'

class PostWithCallbacks < Quandl::Cassandra::Base
  
  table_name :posts
  
  after_initialize :set_values
  
  def set_values
    self.content = 'always change'
    self.author = 'only set as default' unless author.present?
  end
  
end

describe Quandl::Cassandra::Base::Connection do
  subject{ PostWithCallbacks.new( content: 'should be changed', author: 'should not change' ) }
  
  its(:content){ should eq 'always change' }
  its(:author){ should eq 'should not change' }
  its(:changes){ should eq({"content"=>[nil, "always change"], "author"=>[nil, "should not change"]}) }
  
  describe ".new_from_query_result" do
    subject{ PostWithCallbacks.new_from_query_result({ content: 'should be changed', author: 'should not change' }) }
  
    its(:content){ should eq 'always change' }
    its(:author){ should eq 'should not change' }
    its(:changes){ should eq({"content"=>["should be changed", "always change"]}) }
  
  end
  
end