require 'spec_helper'

describe Quandl::Cassandra::Base::Schema do

  describe '#columns' do
    it 'should be a Cql::Client::ResultMetadata' do
      Post.columns.should be_kind_of(Cql::Client::ResultMetadata)
    end

    it 'should re-fetch columns if value not valid Cql::Client::ResultMetadata' do
      Post.instance_variable_set('@columns', {})
      Post.columns.should be_kind_of(Cql::Client::ResultMetadata)
    end
  end

  describe '#column_names' do
    it 'should be an non-empty Array' do
      Post.column_names.should be_kind_of(Array)
      Post.column_names.should_not be_empty
    end

    context 'Column names saved as invalid value' do
      before { Post.instance_variable_set('@column_names', {}) }

      it 'should re-calculate column names' do
        Post.column_names.should be_kind_of(Array)
        Post.column_names.should_not be_empty
      end
    end
  end

  describe '#column_types' do
    it 'should be a non-empty Hash' do
      Post.column_types.should be_kind_of(Hash)
      Post.column_types.should_not be_empty
    end

    context 'Column types saved as invalid value' do
      before { Post.instance_variable_set('@column_types', Object.new) }

      it 'should re-calculate the column type values' do
        Post.column_types.should be_kind_of(Hash)
        Post.column_types.should_not be_empty
      end
    end
  end
end
